Index: sys/net/vnet.h
===================================================================
--- sys/net/vnet.h	(revision 195689)
+++ sys/net/vnet.h	(working copy)
@@ -1,11 +1,7 @@
 /*-
- * Copyright (c) 2006-2008 University of Zagreb
- * Copyright (c) 2006-2008 FreeBSD Foundation
+ * Copyright (c) 2009 Jeffrey Roberson <jeff@freebsd.org>
+ * Copyright (c) 2009 Robert N. M. Watson
  *
- * This software was developed by the University of Zagreb and the
- * FreeBSD Foundation under sponsorship by the Stichting NLnet and the
- * FreeBSD Foundation.
- *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -30,62 +26,131 @@
  * $FreeBSD$
  */
 
+/*
+ * This is the virtual network stack memory allocator, which provides support
+ * for virtualized global variables via a special linker set, set_vnet.  When
+ * "options VIMAGE" isn't defined, virtualized global variables are compiled
+ * as normal globals.
+ */
+
 #ifndef _NET_VNET_H_
 #define	_NET_VNET_H_
 
-#include <net/if_var.h>
+#ifdef _KERNEL
+#ifdef VIMAGE
 
-struct ifindex_entry;
+#if defined(__arm__)
+__asm__(".section set_vnet, \"aw\", %progbits");
+#else
+__asm__(".section set_vnet, \"aw\", @progbits");
+#endif
+__asm__(".previous");
 
-struct vnet_net {
-	int			_if_index;
-	struct ifindex_entry *	_ifindex_table;
-	struct ifnethead	_ifnet;
-	struct ifgrouphead	_ifg_head;
+#define	VNET_NAME(n)		vnet_entry_##n
+#define	VNET_DECLARE(t, n)	extern t VNET_NAME(n)
+#define	VNET_DEFINE(t, n)	t VNET_NAME(n) __section("set_vnet") __used
+#define	_VNET_PTR(b, n)		(__typeof(VNET_NAME(n))*)		\
+				    ((b) + (uintptr_t)&VNET_NAME(n))
 
-	int			_if_indexlim;
+#define	_VNET_GET(b, n)		(*_VNET_PTR(b, n))
+#define	_VNET_SET(b, n, v)	(*_VNET_PTR(b, n) = v)
 
-	struct ifnet *		_loif;
-	struct if_clone *	_lo_cloner;
-	struct ifc_simple_data *_lo_cloner_data;
+/*
+ * Virtualized global variable accessor macros.
+ */
+#define	VNET_VNET_PTR(vnet, n)		_VNET_PTR((vnet)->vnet_data_base, n)
+#define	VNET_VNET_GET(vnet, n)		(*VNET_VNET_PTR((vnet), n))
+#define	VNET_VNET_SET(vnet, n, v)	((*VNET_VNET_PTR((vnet), n)) = v)
 
-	LIST_HEAD(, rawcb)	_rawcb_list;
+#define	VNET_PTR(n)		VNET_VNET_PTR(curvnet, n)
+#define	VNET_GET(n)		VNET_VNET_GET(curvnet, n)
+#define	VNET_SET(n, v)		VNET_VNET_SET(curvnet, n, v)
 
-	LIST_HEAD(, if_clone)	_if_cloners;
-	int			_if_cloners_count;
+/*
+ * Sysctl variants for vnet-virtualized global variables.  Include
+ * <sys/sysctl.h> to expose these definitions.
+ *
+ * Note: SYSCTL_PROC() handler functions will need to resolve pointer
+ * arguments themselves, if required.
+ */
+#ifdef SYSCTL_OID
+int	vnet_sysctl_handle_int(SYSCTL_HANDLER_ARGS);
+int	vnet_sysctl_handle_opaque(SYSCTL_HANDLER_ARGS);
+int	vnet_sysctl_handle_string(SYSCTL_HANDLER_ARGS);
+int	vnet_sysctl_handle_uint(SYSCTL_HANDLER_ARGS);
 
-	int			_ether_ipfw;
-};
+#define	SYSCTL_VNET_INT(parent, nbr, name, access, ptr, val, descr)	\
+	SYSCTL_OID(parent, nbr, name, CTLTYPE_INT|CTLFLAG_MPSAFE|(access), \
+	    ptr, val, vnet_sysctl_handle_int, "I", descr)
+#define	SYSCTL_VNET_PROC(parent, nbr, name, access, ptr, arg, handler,	\
+	    fmt, descr)							\
+	SYSCTL_OID(parent, nbr, name, access, ptr, arg, handler, fmt,	\
+	    descr)
+#define	SYSCTL_VNET_STRING(parent, nbr, name, access, arg, len, descr)	\
+	SYSCTL_OID(parent, nbr, name, CTLTYPE_STRING|(access), arg,	\
+	    len, vnet_sysctl_handle_string, "A", descr)
+#define	SYSCTL_VNET_STRUCT(parent, nbr, name, access, ptr, type, descr)	\
+	SYSCTL_OID(parent, nbr, name, CTLTYPE_OPAQUE|(access), ptr,	\
+	    sizeof(struct type), vnet_sysctl_handle_opaque, "S," #type,	\
+	    descr)
+#define	SYSCTL_VNET_UINT(parent, nbr, name, access, ptr, val, descr)	\
+	SYSCTL_OID(parent, nbr, name, CTLTYPE_UINT|CTLFLAG_MPSAFE|(access), \
+	    ptr, val, vnet_sysctl_handle_uint, "IU", descr)
+#endif /* SYSCTL_OID */
 
-/* Size guard. See sys/vimage.h. */
-VIMAGE_CTASSERT(SIZEOF_vnet_net, sizeof(struct vnet_net));
+/*
+ * Interfaces from the kernel linker.
+ */
+void	*vnet_data_alloc(int size);
+void	 vnet_data_copy(void *start, int size);
+void	 vnet_data_free(void *start_arg, int size);
 
-#ifndef VIMAGE
-#ifndef VIMAGE_GLOBALS
-extern struct vnet_net vnet_net_0;
-#endif
-#endif
+/*
+ * Interfaces for vnet setup/teardown.
+ */
+struct vnet;
+void	 vnet_data_init(struct vnet *vnet);
+void	 vnet_data_destroy(struct vnet *vnet);
 
+#else /* !VIMAGE */
+
 /*
- * Symbol translation macros
+ * Versions of the VNET macros that compile to normal global variables and
+ * standard sysctl definitions.
  */
-#define	INIT_VNET_NET(vnet) \
-	INIT_FROM_VNET(vnet, VNET_MOD_NET, struct vnet_net, vnet_net)
+#define	VNET_NAME(n)		n
+#define	VNET_DECLARE(t, n)	extern t n
+#define	VNET_DEFINE(t, n)	t n
+#define	_VNET_PTR(b, n)		&VNET_NAME(n)
 
-#define	VNET_NET(sym)	VSYM(vnet_net, sym)
+#ifdef SYSCTL_OID
+#define	SYSCTL_VNET_INT(parent, nbr, name, access, ptr, val, descr)	\
+	SYSCTL_INT(parent, nbr, name, access, ptr, val, descr)
+#define	SYSCTL_VNET_PROC(parent, nbr, name, access, ptr, arg, handler,	\
+	    fmt, descr)							\
+	SYSCTL_PROC(parent, nbr, name, access, ptr, arg, handler, fmt,	\
+	    descr)
+#define	SYSCTL_VNET_STRING(parent, nbr, name, access, arg, len, descr)	\
+	SYSCTL_STRING(parent, nbr, name, access, arg, len, descr)
+#define	SYSCTL_VNET_STRUCT(parent, nbr, name, access, ptr, type, descr)	\
+	SYSCTL_STRUCT(parent, nbr, name, access, ptr, type, descr)
+#define	SYSCTL_VNET_UINT(parent, nbr, name, access, ptr, val, descr)	\
+	SYSCTL_UINT(parent, nbr, name, access, ptr, val, descr)
+#endif /* SYSCTL_OID */
 
-#define	V_ether_ipfw		VNET_NET(ether_ipfw)
-#define	V_if_index		VNET_NET(if_index)
-#define	V_if_indexlim		VNET_NET(if_indexlim)
-#define	V_if_cloners		VNET_NET(if_cloners)
-#define	V_if_cloners_count	VNET_NET(if_cloners_count)
-#define	V_ifg_head		VNET_NET(ifg_head)
-#define	V_ifindex_table		VNET_NET(ifindex_table)
-#define	V_ifklist		VNET_NET(ifklist)
-#define	V_ifnet			VNET_NET(ifnet)
-#define	V_lo_cloner		VNET_NET(lo_cloner)
-#define	V_lo_cloner_data	VNET_NET(lo_cloner_data)
-#define	V_loif			VNET_NET(loif)
-#define	V_rawcb_list		VNET_NET(rawcb_list)
+/*
+ * Virtualized global variable accessor macros.
+ */
+#define	VNET_VNET_PTR(vnet, n)		(&(n))
+#define	VNET_VNET_GET(vnet, n)		(n)
+#define	VNET_VNET_SET(vnet, n, v)	((n) = (v))
 
+#define	VNET_PTR(n)		(&(n))
+#define	VNET_GET(n)		(n)
+#define	VNET_SET(n, v)		((n) = (v))
+
+#endif /* VIMAGE */
+
+#endif /* _KERNEL */
+
 #endif /* !_NET_VNET_H_ */
Index: sys/net/bridgestp.c
===================================================================
--- sys/net/bridgestp.c	(revision 195689)
+++ sys/net/bridgestp.c	(working copy)
@@ -2006,7 +2006,6 @@
 void
 bstp_reinit(struct bstp_state *bs)
 {
-	INIT_VNET_NET(curvnet);
 	struct bstp_port *bp;
 	struct ifnet *ifp, *mif;
 	u_char *e_addr;
Index: sys/net/raw_cb.c
===================================================================
--- sys/net/raw_cb.c	(revision 195689)
+++ sys/net/raw_cb.c	(working copy)
@@ -58,9 +58,7 @@
  */
 
 struct mtx rawcb_mtx;
-#ifdef VIMAGE_GLOBALS
-struct rawcb_list_head rawcb_list;
-#endif
+VNET_DEFINE(struct rawcb_list_head, rawcb_list);
 
 SYSCTL_NODE(_net, OID_AUTO, raw, CTLFLAG_RW, 0, "Raw socket infrastructure");
 
@@ -79,7 +77,6 @@
 int
 raw_attach(struct socket *so, int proto)
 {
-	INIT_VNET_NET(so->so_vnet);
 	struct rawcb *rp = sotorawcb(so);
 	int error;
 
Index: sys/net/raw_cb.h
===================================================================
--- sys/net/raw_cb.h	(revision 195689)
+++ sys/net/raw_cb.h	(working copy)
@@ -55,9 +55,9 @@
 #define	RAWRCVQ		8192
 
 #ifdef _KERNEL
-#ifdef VIMAGE_GLOBALS
-extern LIST_HEAD(rawcb_list_head, rawcb) rawcb_list;
-#endif
+VNET_DECLARE(LIST_HEAD(rawcb_list_head, rawcb), rawcb_list);
+#define	V_rawcb_list	VNET_GET(rawcb_list)
+
 extern struct mtx rawcb_mtx;
 
 /*
Index: sys/net/if_vlan.c
===================================================================
--- sys/net/if_vlan.c	(revision 195689)
+++ sys/net/if_vlan.c	(working copy)
@@ -576,7 +576,6 @@
 static struct ifnet *
 vlan_clone_match_ethertag(struct if_clone *ifc, const char *name, int *tag)
 {
-	INIT_VNET_NET(curvnet);
 	const char *cp;
 	struct ifnet *ifp;
 	int t = 0;
Index: sys/net/if_ethersubr.c
===================================================================
--- sys/net/if_ethersubr.c	(revision 195689)
+++ sys/net/if_ethersubr.c	(working copy)
@@ -73,7 +73,7 @@
 #include <netinet/if_ether.h>
 #include <netinet/ip_fw.h>
 #include <netinet/ip_dummynet.h>
-#include <netinet/vinet.h>
+#include <netinet/ip_var.h>
 #endif
 #ifdef INET6
 #include <netinet6/nd6.h>
@@ -148,10 +148,9 @@
 #if defined(INET) || defined(INET6)
 int
 ether_ipfw_chk(struct mbuf **m0, struct ifnet *dst, int shared);
-#ifdef VIMAGE_GLOBALS
-static int ether_ipfw;
+static VNET_DEFINE(int, ether_ipfw);
+#define	V_ether_ipfw	VNET_GET(ether_ipfw)
 #endif
-#endif
 
 
 /*
@@ -434,7 +433,6 @@
 ether_output_frame(struct ifnet *ifp, struct mbuf *m)
 {
 #if defined(INET) || defined(INET6)
-	INIT_VNET_NET(ifp->if_vnet);
 
 	if (ip_fw_chk_ptr && V_ether_ipfw != 0) {
 		if (ether_ipfw_chk(&m, ifp, 0) == 0) {
@@ -463,7 +461,6 @@
 int
 ether_ipfw_chk(struct mbuf **m0, struct ifnet *dst, int shared)
 {
-	INIT_VNET_INET(dst->if_vnet);
 	struct ether_header *eh;
 	struct ether_header save_eh;
 	struct mbuf *m;
@@ -774,7 +771,6 @@
 	KASSERT(ifp != NULL, ("%s: NULL interface pointer", __func__));
 
 #if defined(INET) || defined(INET6)
-	INIT_VNET_NET(ifp->if_vnet);
 	/*
 	 * Allow dummynet and/or ipfw to claim the frame.
 	 * Do not do this for PROMISC frames in case we are re-entered.
@@ -994,8 +990,8 @@
 SYSCTL_DECL(_net_link);
 SYSCTL_NODE(_net_link, IFT_ETHER, ether, CTLFLAG_RW, 0, "Ethernet");
 #if defined(INET) || defined(INET6)
-SYSCTL_V_INT(V_NET, vnet_net, _net_link_ether, OID_AUTO, ipfw, CTLFLAG_RW,
-	     ether_ipfw, 0, "Pass ether pkts through firewall");
+SYSCTL_VNET_INT(_net_link_ether, OID_AUTO, ipfw, CTLFLAG_RW,
+	     &VNET_NAME(ether_ipfw), 0, "Pass ether pkts through firewall");
 #endif
 
 #if 0
Index: sys/net/if_gif.c
===================================================================
--- sys/net/if_gif.c	(revision 195689)
+++ sys/net/if_gif.c	(working copy)
@@ -95,23 +95,22 @@
 static struct mtx gif_mtx;
 static MALLOC_DEFINE(M_GIF, "gif", "Generic Tunnel Interface");
 
-#ifndef VIMAGE
-#ifndef VIMAGE_GLOBALS
-struct vnet_gif vnet_gif_0;
-#endif
-#endif
+static VNET_DEFINE(LIST_HEAD(, gif_softc), gif_softc_list);
+static VNET_DEFINE(int, max_gif_nesting);
+static VNET_DEFINE(int, parallel_tunnels);
 
-#ifdef VIMAGE_GLOBALS
-static LIST_HEAD(, gif_softc) gif_softc_list;
-static int max_gif_nesting;
-static int parallel_tunnels;
+#define	V_gif_softc_list	VNET_GET(gif_softc_list)
+#define	V_max_gif_nesting	VNET_GET(max_gif_nesting)
+#define	V_parallel_tunnels	VNET_GET(parallel_tunnels)
+
 #ifdef INET
-int ip_gif_ttl;
+VNET_DEFINE(int, ip_gif_ttl);
+#define	V_ip_gif_ttl		VNET_GET(ip_gif_ttl)
 #endif
 #ifdef INET6
-int ip6_gif_hlim;
+VNET_DEFINE(int, ip6_gif_hlim);
+#define	V_ip6_gif_hlim		VNET_GET(ip6_gif_hlim)
 #endif
-#endif
 
 void	(*ng_gif_input_p)(struct ifnet *ifp, struct mbuf **mp, int af);
 void	(*ng_gif_input_orphan_p)(struct ifnet *ifp, struct mbuf *m, int af);
@@ -123,11 +122,10 @@
 static void	gif_clone_destroy(struct ifnet *);
 static int	vnet_gif_iattach(const void *);
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 static const vnet_modinfo_t vnet_gif_modinfo = {
 	.vmi_id		= VNET_MOD_GIF,
 	.vmi_name	= "gif",
-	.vmi_size	= sizeof(struct vnet_gif),
 	.vmi_dependson	= VNET_MOD_NET,
 	.vmi_iattach	= vnet_gif_iattach
 };
@@ -151,13 +149,13 @@
  */
 #define MAX_GIF_NEST 1
 #endif
-SYSCTL_V_INT(V_NET, vnet_gif, _net_link_gif, OID_AUTO, max_nesting,
-    CTLFLAG_RW, max_gif_nesting, 0, "Max nested tunnels");
+SYSCTL_VNET_INT(_net_link_gif, OID_AUTO, max_nesting, CTLFLAG_RW,
+    &VNET_NAME(max_gif_nesting), 0, "Max nested tunnels");
 
 #ifdef INET6
 SYSCTL_DECL(_net_inet6_ip6);
-SYSCTL_V_INT(V_NET, vnet_gif, _net_inet6_ip6, IPV6CTL_GIF_HLIM,
-    gifhlim, CTLFLAG_RW, ip6_gif_hlim, 0, "");
+SYSCTL_VNET_INT(_net_inet6_ip6, IPV6CTL_GIF_HLIM, gifhlim, CTLFLAG_RW,
+    &VNET_NAME(ip6_gif_hlim), 0, "");
 #endif
 
 /*
@@ -165,8 +163,8 @@
  * pair of addresses.  Some applications require this functionality so
  * we allow control over this check here.
  */
-SYSCTL_V_INT(V_NET, vnet_gif, _net_link_gif, OID_AUTO, parallel_tunnels,
-    CTLFLAG_RW, parallel_tunnels, 0, "Allow parallel tunnels?");
+SYSCTL_VNET_INT(_net_link_gif, OID_AUTO, parallel_tunnels, CTLFLAG_RW,
+    &VNET_NAME(parallel_tunnels), 0, "Allow parallel tunnels?");
 
 /* copy from src/sys/net/if_ethersubr.c */
 static const u_char etherbroadcastaddr[ETHER_ADDR_LEN] =
@@ -182,7 +180,6 @@
 	int unit;
 	caddr_t params;
 {
-	INIT_VNET_GIF(curvnet);
 	struct gif_softc *sc;
 
 	sc = malloc(sizeof(struct gif_softc), M_GIF, M_WAITOK | M_ZERO);
@@ -265,7 +262,6 @@
 static int
 vnet_gif_iattach(const void *unused __unused)
 {
-	INIT_VNET_GIF(curvnet);
 
 	LIST_INIT(&V_gif_softc_list);
 	V_max_gif_nesting = MAX_GIF_NEST;
@@ -295,7 +291,7 @@
 	case MOD_LOAD:
 		mtx_init(&gif_mtx, "gif_mtx", NULL, MTX_DEF);
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 		vnet_mod_register(&vnet_gif_modinfo);
 #else
 		vnet_gif_iattach(NULL);
@@ -419,7 +415,6 @@
 	struct sockaddr *dst;
 	struct route *ro;
 {
-	INIT_VNET_GIF(ifp->if_vnet);
 	struct gif_softc *sc = ifp->if_softc;
 	struct m_tag *mtag;
 	int error = 0;
@@ -944,7 +939,6 @@
 	struct sockaddr *src;
 	struct sockaddr *dst;
 {
-	INIT_VNET_GIF(ifp->if_vnet);
 	struct gif_softc *sc = ifp->if_softc;
 	struct gif_softc *sc2;
 	struct sockaddr *osrc, *odst, *sa;
Index: sys/net/if_mib.c
===================================================================
--- sys/net/if_mib.c	(revision 195689)
+++ sys/net/if_mib.c	(working copy)
@@ -67,8 +67,8 @@
 SYSCTL_NODE(_net_link_generic, IFMIB_SYSTEM, system, CTLFLAG_RW, 0,
 	    "Variables global to all interfaces");
 
-SYSCTL_V_INT(V_NET, vnet_net, _net_link_generic_system, IFMIB_IFCOUNT,
-	     ifcount, CTLFLAG_RD, if_index, 0,
+SYSCTL_VNET_INT(_net_link_generic_system, IFMIB_IFCOUNT, ifcount, CTLFLAG_RD,
+	    &VNET_NAME(if_index), 0,
 	     "Number of configured interfaces");
 
 static int
Index: sys/net/if_loop.c
===================================================================
--- sys/net/if_loop.c	(revision 195689)
+++ sys/net/if_loop.c	(working copy)
@@ -108,25 +108,26 @@
 static int	vnet_loif_idetach(const void *);
 #endif
 
-#ifdef VIMAGE_GLOBALS
-struct ifnet *loif;			/* Used externally */
-#endif
+VNET_DEFINE(struct ifnet *, loif);	/* Used externally */
 
 #ifdef VIMAGE
+static VNET_DEFINE(struct ifc_simple_data *, lo_cloner_data);
+static VNET_DEFINE(struct if_clone *, lo_cloner);
+#define	V_lo_cloner_data	VNET_GET(lo_cloner_data)
+#define	V_lo_cloner		VNET_GET(lo_cloner)
+
 MALLOC_DEFINE(M_LO_CLONER, "lo_cloner", "lo_cloner");
 #endif
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 static const vnet_modinfo_t vnet_loif_modinfo = {
 	.vmi_id		= VNET_MOD_LOIF,
 	.vmi_dependson	= VNET_MOD_IF_CLONE,
 	.vmi_name	= "loif",
 	.vmi_iattach	= vnet_loif_iattach,
-#ifdef VIMAGE
 	.vmi_idetach	= vnet_loif_idetach
-#endif
 };
-#endif /* !VIMAGE_GLOBALS */
+#endif
 
 IFC_SIMPLE_DECLARE(lo, 1);
 
@@ -147,7 +148,6 @@
 static int
 lo_clone_create(struct if_clone *ifc, int unit, caddr_t params)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 
 	ifp = if_alloc(IFT_LOOP);
@@ -173,10 +173,7 @@
 static int
 vnet_loif_iattach(const void *unused __unused)
 {
-	INIT_VNET_NET(curvnet);
 
-	V_loif = NULL;
-	
 #ifdef VIMAGE
 	V_lo_cloner = malloc(sizeof(*V_lo_cloner), M_LO_CLONER,
 	    M_WAITOK | M_ZERO);
@@ -196,7 +193,6 @@
 static int
 vnet_loif_idetach(const void *unused __unused)
 {
-	INIT_VNET_NET(curvnet);
 
 	if_clone_detach(V_lo_cloner);
 	free(V_lo_cloner, M_LO_CLONER);
@@ -213,7 +209,7 @@
 
 	switch (type) {
 	case MOD_LOAD:
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 		vnet_mod_register(&vnet_loif_modinfo);
 #else
 		vnet_loif_iattach(NULL);
@@ -309,7 +305,6 @@
 int
 if_simloop(struct ifnet *ifp, struct mbuf *m, int af, int hlen)
 {
-	INIT_VNET_NET(ifp->if_vnet);
 	int isr;
 
 	M_ASSERTPKTHDR(m);
Index: sys/net/if_gif.h
===================================================================
--- sys/net/if_gif.h	(revision 195689)
+++ sys/net/if_gif.h	(working copy)
@@ -119,35 +119,9 @@
 void gif_delete_tunnel(struct ifnet *);
 int gif_encapcheck(const struct mbuf *, int, int, void *);
 
-/*
- * Virtualization support
- */
+VNET_DECLARE(int, ip_gif_ttl);
+#define	V_ip_gif_ttl		VNET_GET(ip_gif_ttl)
 
-struct vnet_gif {
-	LIST_HEAD(, gif_softc)	_gif_softc_list;
-	int			_max_gif_nesting;
-	int			_parallel_tunnels;
-	int			_ip_gif_ttl;
-	int			_ip6_gif_hlim;
-};
-
-#ifndef VIMAGE
-#ifndef VIMAGE_GLOBALS
-extern struct vnet_gif vnet_gif_0;
-#endif
-#endif
-
-#define	INIT_VNET_GIF(vnet) \
-	INIT_FROM_VNET(vnet, VNET_MOD_GIF, struct vnet_gif, vnet_gif)
-
-#define	VNET_GIF(sym)	VSYM(vnet_gif, sym)
-
-#define	V_gif_softc_list	VNET_GIF(gif_softc_list)
-#define	V_max_gif_nesting	VNET_GIF(max_gif_nesting)
-#define	V_parallel_tunnels	VNET_GIF(parallel_tunnels)
-#define	V_ip_gif_ttl		VNET_GIF(ip_gif_ttl)
-#define	V_ip6_gif_hlim		VNET_GIF(ip6_gif_hlim)
-
 #endif /* _KERNEL */
 
 #define GIFGOPTS	_IOWR('i', 150, struct ifreq)
Index: sys/net/rtsock.c
===================================================================
--- sys/net/rtsock.c	(revision 195689)
+++ sys/net/rtsock.c	(working copy)
@@ -1238,7 +1238,6 @@
 static void
 rt_dispatch(struct mbuf *m, const struct sockaddr *sa)
 {
-	INIT_VNET_NET(curvnet);
 	struct m_tag *tag;
 
 	/*
@@ -1317,7 +1316,6 @@
 static int
 sysctl_iflist(int af, struct walkarg *w)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 	struct ifaddr *ifa;
 	struct rt_addrinfo info;
@@ -1378,7 +1376,6 @@
 static int
 sysctl_ifmalist(int af, struct walkarg *w)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 	struct ifmultiaddr *ifma;
 	struct	rt_addrinfo info;
Index: sys/net/if_faith.c
===================================================================
--- sys/net/if_faith.c	(revision 195689)
+++ sys/net/if_faith.c	(working copy)
@@ -77,7 +77,6 @@
 #include <netinet6/in6_var.h>
 #include <netinet/ip6.h>
 #include <netinet6/ip6_var.h>
-#include <netinet6/vinet6.h>
 #endif
 
 #define FAITHNAME	"faith"
@@ -328,7 +327,6 @@
 faithprefix(in6)
 	struct in6_addr *in6;
 {
-	INIT_VNET_INET6(curvnet);
 	struct rtentry *rt;
 	struct sockaddr_in6 sin6;
 	int ret;
Index: sys/net/if_var.h
===================================================================
--- sys/net/if_var.h	(revision 195689)
+++ sys/net/if_var.h	(working copy)
@@ -80,6 +80,7 @@
 #include <sys/mbuf.h>
 #include <sys/eventhandler.h>
 #include <sys/buf_ring.h>
+#include <net/vnet.h>
 #endif /* _KERNEL */
 #include <sys/lock.h>		/* XXX */
 #include <sys/mutex.h>		/* XXX */
@@ -779,11 +780,16 @@
  */
 struct ifaddr	*ifaddr_byindex(u_short idx);
 
-#ifdef VIMAGE_GLOBALS
-extern	struct ifnethead ifnet;
-extern	struct ifnet *loif;	/* first loopback interface */
-extern	int if_index;
-#endif
+VNET_DECLARE(struct ifnethead, ifnet);
+VNET_DECLARE(struct ifgrouphead, ifg_head);
+VNET_DECLARE(int, if_index);
+VNET_DECLARE(struct ifnet *, loif);	/* first loopback interface */
+
+#define	V_ifnet		VNET_GET(ifnet)
+#define	V_ifg_head	VNET_GET(ifg_head)
+#define	V_if_index	VNET_GET(if_index)
+#define	V_loif		VNET_GET(loif)
+
 extern	int ifqmaxlen;
 
 int	if_addgroup(struct ifnet *, const char *);
Index: sys/net/if_enc.c
===================================================================
--- sys/net/if_enc.c	(revision 195689)
+++ sys/net/if_enc.c	(working copy)
@@ -47,6 +47,7 @@
 #include <net/route.h>
 #include <net/netisr.h>
 #include <net/bpf.h>
+#include <net/vnet.h>
 
 #include <netinet/in.h>
 #include <netinet/in_systm.h>
Index: sys/net/raw_usrreq.c
===================================================================
--- sys/net/raw_usrreq.c	(revision 195689)
+++ sys/net/raw_usrreq.c	(working copy)
@@ -58,7 +58,6 @@
 void
 raw_init(void)
 {
-	INIT_VNET_NET(curvnet);
 
 	LIST_INIT(&V_rawcb_list);
 }
@@ -73,7 +72,6 @@
 void
 raw_input(struct mbuf *m0, struct sockproto *proto, struct sockaddr *src)
 {
-	INIT_VNET_NET(curvnet);
 	struct rawcb *rp;
 	struct mbuf *m = m0;
 	struct socket *last;
Index: sys/net/if_gre.c
===================================================================
--- sys/net/if_gre.c	(revision 195689)
+++ sys/net/if_gre.c	(working copy)
@@ -80,7 +80,6 @@
 #include <netinet/ip_gre.h>
 #include <netinet/ip_var.h>
 #include <netinet/ip_encap.h>
-#include <netinet/vinet.h>
 #else
 #error "Huh? if_gre without inet?"
 #endif
@@ -243,9 +242,6 @@
 gre_output(struct ifnet *ifp, struct mbuf *m, struct sockaddr *dst,
 	   struct route *ro)
 {
-#ifdef INET6
-	INIT_VNET_INET(ifp->if_vnet);
-#endif
 	int error = 0;
 	struct gre_softc *sc = ifp->if_softc;
 	struct greip *gh;
Index: sys/net/if_spppsubr.c
===================================================================
--- sys/net/if_spppsubr.c	(revision 195689)
+++ sys/net/if_spppsubr.c	(working copy)
@@ -56,7 +56,6 @@
 #ifdef INET
 #include <netinet/ip.h>
 #include <netinet/tcp.h>
-#include <netinet/vinet.h>
 #endif
 
 #ifdef INET6
@@ -4937,7 +4936,6 @@
 static void
 sppp_set_ip_addr(struct sppp *sp, u_long src)
 {
-	INIT_VNET_INET(curvnet);
 	STDDCL;
 	struct ifaddr *ifa;
 	struct sockaddr_in *si;
Index: sys/ddb/ddb.h
===================================================================
--- sys/ddb/ddb.h	(revision 195689)
+++ sys/ddb/ddb.h	(working copy)
@@ -213,6 +213,8 @@
 void		db_trace_self(void);
 int		db_trace_thread(struct thread *, int);
 int		db_value_of_name(const char *name, db_expr_t *valuep);
+int		db_value_of_name_pcpu(const char *name, db_expr_t *valuep);
+int		db_value_of_name_vnet(const char *name, db_expr_t *valuep);
 int		db_write_bytes(vm_offset_t addr, size_t size, char *data);
 void		db_command_register(struct command_table *, struct command *);
 void		db_command_unregister(struct command_table *, struct command *);
Index: sys/ddb/db_variables.c
===================================================================
--- sys/ddb/db_variables.c	(revision 195689)
+++ sys/ddb/db_variables.c	(working copy)
@@ -46,6 +46,12 @@
 	{ "maxwidth",	&db_max_width, FCN_NULL },
 	{ "tabstops",	&db_tab_stop_width, FCN_NULL },
 	{ "lines",	&db_lines_per_page, FCN_NULL },
+	{ "curcpu",	NULL, db_var_curcpu },
+	{ "db_cpu",	NULL, db_var_db_cpu },
+#ifdef VIMAGE
+	{ "curvnet",	NULL, db_var_curvnet },
+	{ "db_vnet",	NULL, db_var_db_vnet },
+#endif
 };
 static struct db_variable *db_evars =
 	db_vars + sizeof(db_vars)/sizeof(db_vars[0]);
Index: sys/ddb/db_sym.c
===================================================================
--- sys/ddb/db_sym.c	(revision 195689)
+++ sys/ddb/db_sym.c	(working copy)
@@ -32,10 +32,15 @@
 __FBSDID("$FreeBSD$");
 
 #include <sys/param.h>
+#include <sys/smp.h>
 #include <sys/systm.h>
+#include <sys/vimage.h>
 
+#include <net/vnet.h>
+
 #include <ddb/ddb.h>
 #include <ddb/db_sym.h>
+#include <ddb/db_variables.h>
 
 #include <opt_ddb.h>
 
@@ -56,7 +61,118 @@
 static boolean_t	db_symbol_is_ambiguous(c_db_sym_t sym);
 static boolean_t	db_line_at_pc(c_db_sym_t, char **, int *, db_expr_t);
 
+static int db_cpu = -1;
+
+#ifdef VIMAGE
+extern uintptr_t	*__start_set_vnet;
+extern uintptr_t	*__stop_set_vnet;
+
+#define	VNET_START	(uintptr_t)&__start_set_vnet
+#define	VNET_STOP	(uintptr_t)&__stop_set_vnet
+
+static void *db_vnet = NULL;
+#endif
+
 /*
+ * Validate the CPU number used to interpret per-CPU variables so we can
+ * avoid later confusion if an invalid CPU is requested.
+ */
+int
+db_var_db_cpu(struct db_variable *vp, db_expr_t *valuep, int op)
+{
+
+	switch (op) {
+	case DB_VAR_GET:
+		*valuep = db_cpu;
+		return (1);
+
+	case DB_VAR_SET:
+		if (*(int *)valuep < -1 && *(int *)valuep > mp_maxid) {
+			db_printf("Invalid value: %d", *(int*)valuep);
+			return (0);
+		}
+		db_cpu = *(int *)valuep;
+		return (1);
+
+	default:
+		db_printf("db_var_db_cpu: unknown operation\n");
+		return (0);
+	}
+}
+
+/*
+ * Read-only variable reporting the current CPU, which is what we use when
+ * db_cpu is set to -1.
+ */
+int
+db_var_curcpu(struct db_variable *vp, db_expr_t *valuep, int op)
+{
+
+	switch (op) {
+	case DB_VAR_GET:
+		*valuep = curcpu;
+		return (1);
+
+	case DB_VAR_SET:
+		db_printf("Read-only variable.\n");
+		return (0);
+
+	default:
+		db_printf("db_var_curcpu: unknown operation\n");
+		return (0);
+	}
+}
+
+#ifdef VIMAGE
+/*
+ * Validate the virtual network pointer used to interpret per-vnet global
+ * variable expansion.  Right now we don't do much here, really we should
+ * walk the global vnet list to check it's an OK pointer.
+ */
+int
+db_var_db_vnet(struct db_variable *vp, db_expr_t *valuep, int op)
+{
+
+	switch (op) {
+	case DB_VAR_GET:
+		*valuep = (db_expr_t)db_vnet;
+		return (1);
+
+	case DB_VAR_SET:
+		db_vnet = *(void **)valuep;
+		return (1);
+
+	default:
+		db_printf("db_var_db_vnet: unknown operation\n");
+		return (0);
+	}
+}
+
+/*
+ * Read-only variable reporting the current vnet, which is what we use when
+ * db_vnet is set to NULL.
+ */
+int
+db_var_curvnet(struct db_variable *vp, db_expr_t *valuep, int op)
+{
+
+	switch (op) {
+	case DB_VAR_GET:
+		*valuep = (db_expr_t)curvnet;
+		return (1);
+
+	case DB_VAR_SET:
+		db_printf("Read-only variable.\n");
+		return (0);
+
+	default:
+		db_printf("db_var_curcpu: unknown operation\n");
+		return (0);
+	}
+}
+#endif
+
+/*
  * Add symbol table, with given name, to list of symbol tables.
  */
 void
@@ -125,7 +241,60 @@
 	return (TRUE);
 }
 
+boolean_t
+db_value_of_name_pcpu(name, valuep)
+	const char	*name;
+	db_expr_t	*valuep;
+{
+	static char     tmp[256];
+	db_expr_t	value;
+	c_db_sym_t	sym;
+	int		cpu;
 
+	if (db_cpu != -1)
+		cpu = db_cpu;
+	else
+		cpu = curcpu;
+	snprintf(tmp, sizeof(tmp), "pcpu_entry_%s", name);
+	sym = db_lookup(tmp);
+	if (sym == C_DB_SYM_NULL)
+		return (FALSE);
+	db_symbol_values(sym, &name, &value);
+	if (value < DPCPU_START || value >= DPCPU_STOP)
+		return (FALSE);
+	*valuep = (db_expr_t)((uintptr_t)value + dpcpu_off[cpu]);
+	return (TRUE);
+}
+
+boolean_t
+db_value_of_name_vnet(name, valuep)
+	const char	*name;
+	db_expr_t	*valuep;
+{
+#ifdef VIMAGE
+	static char     tmp[256];
+	db_expr_t	value;
+	c_db_sym_t	sym;
+	struct vnet	*vnet;
+
+	if (db_vnet != NULL)
+		vnet = db_vnet;
+	else
+		vnet = curvnet;
+	snprintf(tmp, sizeof(tmp), "vnet_entry_%s", name);
+	sym = db_lookup(tmp);
+	if (sym == C_DB_SYM_NULL)
+		return (FALSE);
+	db_symbol_values(sym, &name, &value);
+	if (value < VNET_START || value >= VNET_STOP)
+		return (FALSE);
+	*valuep = (db_expr_t)((uintptr_t)value + vnet->vnet_data_base);
+	return (TRUE);
+#else
+	return (FALSE);
+#endif
+}
+
 /*
  * Lookup a symbol.
  * If the symbol has a qualifier (e.g., ux:vm_map),
Index: sys/ddb/db_variables.h
===================================================================
--- sys/ddb/db_variables.h	(revision 195689)
+++ sys/ddb/db_variables.h	(working copy)
@@ -52,6 +52,11 @@
 extern struct db_variable	db_regs[];	/* machine registers */
 extern struct db_variable	*db_eregs;
 
+extern db_varfcn_t	db_var_curcpu;		/* DPCPU default CPU */
+extern db_varfcn_t	db_var_curvnet;		/* Default vnet */
+extern db_varfcn_t	db_var_db_cpu;		/* DPCPU active CPU */
+extern db_varfcn_t	db_var_db_vnet;		/* Active vnet */
+
 int db_read_variable(struct db_variable *, db_expr_t *);
 int db_write_variable(struct db_variable *, db_expr_t);
 
Index: sys/ddb/db_expr.c
===================================================================
--- sys/ddb/db_expr.c	(revision 195689)
+++ sys/ddb/db_expr.c	(working copy)
@@ -51,7 +51,9 @@
 
 	t = db_read_token();
 	if (t == tIDENT) {
-	    if (!db_value_of_name(db_tok_string, valuep)) {
+	    if (!db_value_of_name(db_tok_string, valuep) &&
+		!db_value_of_name_pcpu(db_tok_string, valuep) &&
+		!db_value_of_name_vnet(db_tok_string, valuep)) {
 		db_error("Symbol not found\n");
 		/*NOTREACHED*/
 	    }
Index: sys/netinet6/in6_ifattach.c
===================================================================
--- sys/netinet6/in6_ifattach.c	(revision 195689)
+++ sys/netinet6/in6_ifattach.c	(working copy)
@@ -53,7 +53,9 @@
 #include <netinet/in_var.h>
 #include <netinet/if_ether.h>
 #include <netinet/in_pcb.h>
-#include <netinet/vinet.h>
+#include <netinet/ip_var.h>
+#include <netinet/udp.h>
+#include <netinet/udp_var.h>
 
 #include <netinet/ip6.h>
 #include <netinet6/ip6_var.h>
@@ -64,15 +66,16 @@
 #include <netinet6/nd6.h>
 #include <netinet6/mld6_var.h>
 #include <netinet6/scope6_var.h>
-#include <netinet6/vinet6.h>
 
-#ifdef VIMAGE_GLOBALS
-unsigned long in6_maxmtu;
-int ip6_auto_linklocal;
-struct callout in6_tmpaddrtimer_ch;
-extern struct inpcbinfo ripcbinfo;
-#endif
+VNET_DEFINE(unsigned long, in6_maxmtu);
+VNET_DEFINE(int, ip6_auto_linklocal);
+VNET_DEFINE(struct callout, in6_tmpaddrtimer_ch);
 
+#define	V_in6_tmpaddrtimer_ch		VNET_GET(in6_tmpaddrtimer_ch)
+
+VNET_DECLARE(struct inpcbinfo, ripcbinfo);
+#define	V_ripcbinfo			VNET_GET(ripcbinfo)
+
 static int get_rand_ifid(struct ifnet *, struct in6_addr *);
 static int generate_tmp_ifid(u_int8_t *, const u_int8_t *, u_int8_t *);
 static int get_ifid(struct ifnet *, struct ifnet *, struct in6_addr *);
@@ -142,7 +145,6 @@
 static int
 generate_tmp_ifid(u_int8_t *seed0, const u_int8_t *seed1, u_int8_t *ret)
 {
-	INIT_VNET_INET6(curvnet);
 	MD5_CTX ctxt;
 	u_int8_t seed[16], digest[16], nullbuf[8];
 	u_int32_t val32;
@@ -379,8 +381,6 @@
 get_ifid(struct ifnet *ifp0, struct ifnet *altifp,
     struct in6_addr *in6)
 {
-	INIT_VNET_NET(ifp0->if_vnet);
-	INIT_VNET_INET6(ifp0->if_vnet);
 	struct ifnet *ifp;
 
 	/* first, try to get it from the interface itself */
@@ -444,7 +444,6 @@
 static int
 in6_ifattach_linklocal(struct ifnet *ifp, struct ifnet *altifp)
 {
-	INIT_VNET_INET6(curvnet);
 	struct in6_ifaddr *ia;
 	struct in6_aliasreq ifra;
 	struct nd_prefixctl pr0;
@@ -562,7 +561,6 @@
 static int
 in6_ifattach_loopback(struct ifnet *ifp)
 {
-	INIT_VNET_INET6(curvnet);
 	struct in6_aliasreq ifra;
 	int error;
 
@@ -694,7 +692,6 @@
 void
 in6_ifattach(struct ifnet *ifp, struct ifnet *altifp)
 {
-	INIT_VNET_INET6(ifp->if_vnet);
 	struct in6_ifaddr *ia;
 	struct in6_addr in6;
 
@@ -782,8 +779,6 @@
 void
 in6_ifdetach(struct ifnet *ifp)
 {
-	INIT_VNET_INET(ifp->if_vnet);
-	INIT_VNET_INET6(ifp->if_vnet);
 	struct in6_ifaddr *ia;
 	struct ifaddr *ifa, *next;
 	struct radix_node_head *rnh;
@@ -908,8 +903,6 @@
 in6_tmpaddrtimer(void *arg)
 {
 	CURVNET_SET((struct vnet *) arg);
-	INIT_VNET_NET(curvnet);
-	INIT_VNET_INET6(curvnet);
 	struct nd_ifinfo *ndi;
 	u_int8_t nullbuf[8];
 	struct ifnet *ifp;
